#ifndef APP_H
#define APP_H

#include <QObject>
#include <QMap>
#include <QString>
#include <QDebug>
#include <QDBusServiceWatcher>
#include "ukui-log4qt.h"
#include "CSingleton.h"

class Application
{
public:
    explicit Application(QString, QString, int);
    ~Application();

    QString dbusid(){ return m_dbusid; }
    QString username(){ return m_username; }
    int type(){ return m_type; }

protected:
    QString m_dbusid;
    QString m_username;
    int m_type = 0;
};


class ApplicationMng: public QObject
{
public:
    ApplicationMng();
    ~ApplicationMng();

public:
    int add(QString, QString, int);

    int remove(QString);

    int getControlNum(void);

    int getAllNum(void) { return m_apps.size(); }

    bool existDbusid(QString);

    QStringList getRegisterClient(void);
    //int unknownDbusid(QString, );
private:
    void update(void);

protected slots:
    void serviceUnregistered(const QString &service);


protected:
    QMap<QString, Application *> m_apps;
    QDBusServiceWatcher * m_watch = nullptr;

    friend class SingleTon<ApplicationMng>;
};
typedef SingleTon<ApplicationMng>  APPMNG;

#endif // APP_H
