#include "bluetoothobexagent.h"
#include "filesess.h"

BluetoothObexAgent::BluetoothObexAgent(QObject *parent):ObexAgent(parent)
{
    KyInfo();
}

BluetoothObexAgent::~BluetoothObexAgent()
{
    KyInfo();
}


QDBusObjectPath BluetoothObexAgent::objectPath() const
{
    return QDBusObjectPath(QStringLiteral("/org/bluez/obex/Agent1"));
}


void BluetoothObexAgent::authorizePush(BluezQt::ObexTransferPtr transfer, BluezQt::ObexSessionPtr session, const BluezQt::Request<QString> &request)
{
    KyInfo();
    if(nullptr == transfer || nullptr == session)
    {
        request.reject();
    }
    m_session = session;
    FILESESSMNG::getInstance()->receiveFiles(transfer, session, request);
}


void BluetoothObexAgent::cancel()
{
    FILESESSMNG::getInstance()->sessionCanceled(m_session);
    KyInfo();
}

void BluetoothObexAgent::release()
{
    KyInfo();
}

