#include "bluetooth.h"

Environment envPC = Environment::NOMAL;

Bluetooth::Bluetooth() : mFirstLoad(true) {

    KyDebug() << "start" << "++ukccBluetooth========================";
    QStringList addrList = BlueToothDBusService::getAllAdapterAddress();
    if (!addrList.size())
        ukccbluetoothconfig::ukccGsetting->set("show",QVariant(false));
    else
        ukccbluetoothconfig::ukccGsetting->set("show",QVariant(true));

    KyDebug() << envPC ;

    QTranslator * translator = new QTranslator(this);;
    translator->load("/usr/share/ukui-bluetooth/translations/ukcc-bluetooth_" + QLocale::system().name() + ".qm");
    QApplication::installTranslator(translator);

    pluginName = tr("Bluetooth");
    pluginType = DEVICES;
}

Bluetooth::~Bluetooth() {
    if (!mFirstLoad) {
        pluginWidget->deleteLater();
    }
}

QString Bluetooth::plugini18nName() {
    return pluginName;
}

int Bluetooth::pluginTypes() {
    return pluginType;
}

QWidget *Bluetooth::pluginUi() {

    if (mFirstLoad) {
        mFirstLoad = false;
        pluginWidget = new BlueToothMainWindow;
    }

    if (!mFirstLoad && (nullptr != pluginWidget))
    {
        BlueToothDBusService::registerClient();
    }

    return pluginWidget;
}

const QString Bluetooth::name() const {
    return QStringLiteral("Bluetooth");
}

bool Bluetooth::isShowOnHomePage() const
{
    return true;
}

QIcon Bluetooth::icon() const
{
    return QIcon::fromTheme("bluetooth-active-symbolic");
}

bool Bluetooth::isEnable() const
{
    QStringList addrList = BlueToothDBusService::getAllAdapterAddress();
    KyDebug() << addrList ;
    if (addrList.size())
    {
        KyDebug() << "Bluetooth::isEnable is true";
        return true;
    }
    else
    {
        KyDebug() << "Bluetooth::isEnable is false";
        return false;
    }
}

void Bluetooth::plugin_leave()
{
    if (nullptr != pluginWidget)
    {
        //界面切出时注销控制面板注册
        BlueToothDBusService::unregisterClient();
    }
}
