#ifndef DEVRENAMEDIALOG_H
#define DEVRENAMEDIALOG_H

#include <QIcon>
#include <QLabel>
#include <QDebug>
#include <QDialog>
#include <QVariant>
#include <QPalette>
#include <QPainter>
#include <QLineEdit>
#include <QKeyEvent>
#include <QGSettings>
#include <QPushButton>
#include <QHBoxLayout>

#include <ukcc/widgets/titlelabel.h>

#include "config.h"

#define INPUT_STRNAME_MIN 1
#define INPUT_STRNAME_MAX 32

class DevRenameDialog : public QDialog
{
    Q_OBJECT
public:
    enum DEV_RENAME_DIALOG_TYPE
    {
        DEVRENAMEDIALOG_ADAPTER = 0,
        DEVRENAMEDIALOG_BT_DEVICE = 1
    };
    Q_ENUM(DEV_RENAME_DIALOG_TYPE)

    explicit DevRenameDialog(QWidget *parent = nullptr);

    ~DevRenameDialog();

    void setDevName(const QString &);
    void setRenameInterface(DEV_RENAME_DIALOG_TYPE mode);

    void initGsettings();

    QLabel * titleLabel = nullptr;
    QLabel * textLabel  = nullptr;
    DEV_RENAME_DIALOG_TYPE _mMode = DEVRENAMEDIALOG_ADAPTER;
private slots:
    void gsettingsSlot(const QString &);

protected:
    void paintEvent(QPaintEvent *);
    void keyPressEvent(QKeyEvent *);

public slots:
    void lineEditSlot(const QString &);

signals:
    void nameChanged(QString);

private:
    void initUI();

    int  _fontSize;

    bool isblack = false;

    QString adapterOldName;

    QLabel *tipLabel   = nullptr;

    QGSettings *gsettings  = nullptr;

    QPushButton *closeBtn  = nullptr;

    QPushButton *acceptBtn = nullptr;

    QPushButton *rejectBtn = nullptr;

    QLineEdit   *lineEdit  = nullptr;
};

#endif // DEVRENAMEDIALOG_H
