#ifndef LOADINGLABEL_H
#define LOADINGLABEL_H

#include <QIcon>
#include <QDebug>
#include <QTimer>
#include <QWidget>
#include <QPainter>
#include <QGSettings>
#include <QPaintEvent>

#include "config.h"
#include "ukccbluetoothconfig.h"

class LoadingLabel : public QWidget
{
    Q_OBJECT
public:
    explicit LoadingLabel(QObject *parent = nullptr);
    ~LoadingLabel();
    void setTimerStop();
    void setTimerStart();
    void setTimeReresh(int);

private Q_SLOTS:
    void refreshIconNum();
    void mStyle_GSettingsSlot(const QString &key);

protected:
    void paintEvent(QPaintEvent *e);

private:
    int     index = 0;
    QTimer *m_timer;
    bool        _themeIsBlack = false;
    QGSettings * _mStyle_GSettings  = nullptr;

    void initGsettings();
};

#endif // LOADINGLABEL_H
