#ifndef UKCCBLUETOOTHCONFIG_H
#define UKCCBLUETOOTHCONFIG_H

#include <QFile>
#include <QDebug>
#include <QPixmap>
#include <QProcess>
#include <QGSettings>
#include <ukui-log4qt.h>

#ifdef UKCC_BLUETOOTH_DATA_BURIAL_POINT
    #include <ukcc/interface/ukcccommon.h>
#endif

#include "kysdk/kysdk-system/libkysysinfo.h"

#include "config.h"

class ukccbluetoothconfig
{
public:
    ukccbluetoothconfig();
    ~ukccbluetoothconfig();
    enum PixmapColor {
            WHITE = 0,
            BLACK,
            GRAY,
            BLUE,
            DEFAULT
    };
    static QGSettings *ukccGsetting;

    static bool ukccBtBuriedSettings(QString pluginName, QString settingsName, QString action, QString value = nullptr);
    static void launchBluetoothServiceStart(const QString &processName);
    static void killAppProcess(const quint64 &processId);
    static bool checkProcessRunning(const QString &processName, QList<quint64> &listProcessId);
    static void setEnvPCValue();
    static const QPixmap loadSvg(const QPixmap &source, const PixmapColor &cgColor);
    static const QImage loadSvgImage(const QPixmap &source, const PixmapColor &cgColor);

};

#endif // UKCCBLUETOOTHCONFIG_H
