#ifndef TRAYICON_H
#define TRAYICON_H

#include <glib.h>
#include <glib/gprintf.h>
#include <iostream>
#include <QApplication>
#include <QWidget>
#include <QSystemTrayIcon>
#include <QAction>
#include <QString>
#include <QMenu>
#include <QGSettings>
#include <QDebug>

#ifdef KYSEC
#include <kysec/libkysec.h>
#include <kysec/status.h>
#endif

#include "config/config.h"

using namespace std;

class TrayIcon : public QWidget
{
    Q_OBJECT

public:
    TrayIcon(bool _trayshow, bool _existAdapter, QWidget *parent = nullptr);
    ~TrayIcon();
    void InitTrayWidget();
    void SetAdapterFlag(bool set);
    void setClickEnable(bool enable);
    void setAdapterExist(bool exist);

signals:
    void showTayWidget();
    void openBluetoothSettings();

public slots:
    void SetTrayIcon(bool open);

private:
    QSystemTrayIcon *bluetooth_tray_icon = nullptr;
    QMenu           *tray_Menu           = nullptr;
    QGSettings      *settings            = nullptr;
    QGSettings      *ukccGsetting        = nullptr;
    bool            existAdapter         = false;
    bool            secState             = false;
    bool            clickEnable          = true;
    bool            existSettings        = false;
} ;
#endif // TRAYICON_H
